// Generated by CoffeeScript 1.10.0
(function() {
  var bodyParser, cors, express, expressErrorResponse;

  express = require('express');

  bodyParser = require('body-parser');

  expressErrorResponse = require('express-response-error');

  cors = require('cors');

  module.exports = function(database, entityName, options) {
    var router;
    if (options == null) {
      options = {};
    }
    router = express.Router();
    router.use(expressErrorResponse(options.error));
    router.use(bodyParser.json({
      limit: '2mb'
    }));
    router.use(cors({
      allowedHeaders: 'Content-Range,Content-Type,Range,Authorization',
      exposedHeaders: 'Content-Range'
    }));
    router.use(function(req, res, next) {
      if (!req.context && database) {
        return database.middleware()(req, res, next);
      } else {
        return next();
      }
    });
    router.use(function(req, res, next) {
      if (!req.context) {
        return next(new Error('req.context does not contain js-core-data context'));
      } else {
        req.entity = req.context.storeCoordinator.objectModel.getEntity(entityName);
      }
      return next();
    });
    return router;
  };

}).call(this);
