// Generated by CoffeeScript 1.10.0
(function() {
  var Promise, async, cors, express, expressResponseRange, processOrderParam, processQueryParam;

  express = require('express');

  cors = require('cors');

  async = require('async');

  expressResponseRange = require('express-response-range');

  Promise = require('bluebird');

  processOrderParam = function(order) {
    if (order) {
      order = order.split(',');
      return order.map(function(x) {
        x = x.replace(/^(-?([a-zA-Z0-9\._]\.)*)id/, '$1_id');
        return x;
      });
    }
    return null;
  };

  processQueryParam = function(req, entity) {
    var allFields, attribute, column, columnWhere, fieldName, fieldValue, i, j, k, len, len1, len2, q, queryWhere, ref, ref1, searchColumns, searchString, searchStrings, where, wordWhere;
    q = req.query.q;
    if (!q) {
      return void 0;
    }
    where = {};
    if (q) {
      searchStrings = q.split(' ');
      queryWhere = [];
      searchColumns = [];
      allFields = false;
      if (req.query.fields) {
        ref = req.query.fields;
        for (fieldName in ref) {
          fieldValue = ref[fieldName];
          if (fieldValue !== 'SELF.*' && fieldValue !== '*') {
            searchColumns.push(fieldName);
          } else {
            allFields = true;
          }
        }
      } else {
        allFields = true;
      }
      if (allFields) {
        ref1 = entity.getNonTransientAttributes();
        for (i = 0, len = ref1.length; i < len; i++) {
          attribute = ref1[i];
          searchColumns.push(attribute.name);
        }
      }
      for (j = 0, len1 = searchStrings.length; j < len1; j++) {
        searchString = searchStrings[j];
        wordWhere = [];
        for (k = 0, len2 = searchColumns.length; k < len2; k++) {
          column = searchColumns[k];
          columnWhere = {
            $or: [{}, {}]
          };
          columnWhere.$or[0]['LOWER(CAST(SELF.' + column + ' AS text))?'] = searchString.toLocaleLowerCase() + '*';
          columnWhere.$or[1]['LOWER(CAST(SELF.' + column + ' AS text))?'] = '* ' + searchString.toLocaleLowerCase() + '*';
          wordWhere.push(columnWhere);
        }
        queryWhere.push({
          $or: wordWhere
        });
      }
      where = {
        $and: queryWhere
      };
    }
    return where;
  };

  module.exports = function(entityName, options) {
    var getter, router;
    if (options == null) {
      options = {};
    }
    router = express.Router();
    getter = options.getValues || function(data) {
      return Promise.resolve(data.item.getValues());
    };
    router.use(expressResponseRange(options));
    router.get('/', (function(_this) {
      return function(req, res, next) {
        var fields, order, qWhere, where;
        where = {};
        order = processOrderParam(req.query.order);
        qWhere = processQueryParam(req, req.entity);
        if (req.query.where && qWhere) {
          where = {
            $and: [qWhere, req.query.where]
          };
        } else {
          where = req.query.where || qWhere;
        }
        fields = req.query.fields;
        return req.context.getObjectsCount(entityName, {
          fields: fields,
          where: where
        }).then(function(itemsCount) {
          return req.context.fetch(entityName, {
            where: where,
            fields: fields,
            limit: req.range.limit,
            offset: req.range.offset,
            order: order || 'SELF._id',
            group: req.query.group
          }).then(function(items) {
            var i, item, len;
            for (i = 0, len = items.length; i < len; i++) {
              item = items[i];
              item.id = item._id;
              delete item._id;
            }
            return res.sendRange(items, itemsCount);
          });
        })["catch"](next);
      };
    })(this));
    return router.get('/:id', function(req, res, next) {
      return req.context.getObjectWithId(entityName, req.params.id).then(function(item) {
        if (!item) {
          return res.notFound(entityName + ' with id ' + req.params.id + ' not found');
        }
        return getter({
          item: item,
          req: req
        }).then(function(data) {
          return res.send(data);
        });
      })["catch"](next);
    });
  };

}).call(this);
